<template>
	<div class="OfflineMapButton">
		<span v-if="showCaption" class="caption">Offline</span>
		<!-- readonly because v-switch won't honor our input-value if we let it handle user interaction events. A hack to workaround a bug. -->
		<v-switch
			inset
			:loading="offlineMapAsyncState.isLoading"
			:disabled="disabled"
			@click="handleClick"
			readonly
			:input-value="offlineMapAsyncState.isLoaded"
			:value="true"
		></v-switch>
		<v-snackbar v-model="offlineMapAsyncState.hasError" color="error"> Failed to download field. </v-snackbar>
	</div>
</template>

<script>
import { useOfflineMapAsyncState } from '@/store/modules/offlineMaps';
import { defineComponent, computed } from '@vue/composition-api';

export default defineComponent({
	props: {
		fieldId: {
			type: String,
			required: true,
		},
		showCaption: {
			type: Boolean,
			default: true,
		},
	},
	setup(props, { root }) {
		const offlineMapAsyncState = computed(() => useOfflineMapAsyncState(root.$store)(props.fieldId));
		const disabled = computed(() => offlineMapAsyncState.value.isLoading || offlineMapAsyncState.value.isLoaded);

		function handleClick() {
			if (!offlineMapAsyncState.value.isLoading && !offlineMapAsyncState.value.isLoaded) {
				root.$store.dispatch('offlineMaps/fetchOfflineMap', props.fieldId);
			}
		}

		return {
			disabled,
			handleClick,
			offlineMapAsyncState,
		};
	},
});
</script>

<style>
.OfflineMapButton {
	display: flex;
	flex-direction: column;
	justify-content: center;
}

.OfflineMapButton .v-input--selection-controls {
	margin-top: 0;
}

.OfflineMapButton .v-messages {
	display: none;
}
</style>
